import 'dart:async';
import 'package:after_layout/after_layout.dart';
import 'package:bolter/bolter.dart';
import 'package:bolter_flutter/bolter_flutter.dart';
import 'package:dependencies_container/dependencies_container.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:provider/provider.dart';
import 'package:provider/single_child_widget.dart';

part 'presenter/presenter.dart';
part 'presenter/presenter_provider.dart';

class BolterProvider extends InheritedWidget {
  BolterProvider({
    required DependenciesContainer container,
    Object? flutterState,
    Key? key,
    required Widget child,
  })  : _container = container,
        _flutterState = flutterState,
        super(key: key, child: child);

  final DependenciesContainer _container;
  final _bolter = Bolter();
  final Object? _flutterState;

  static BolterProvider of(BuildContext context) => context.dependOnInheritedWidgetOfExactType(aspect: BolterProvider)!;

  T dependency<T>() => _container.dependency<T>();

  DependenciesContainer get dependenciesContainer => _container;

  @override
  bool updateShouldNotify(BolterProvider oldWidget) => false;
}
