import 'dart:async';

// class MyRoute extends BolterRoute<void>{
//   @override
//   Object get key => throw UnimplementedError();
//
// }

abstract class BolterRoute<R> {
  final _completer = Completer<R?>();

  R? result;

  @override
  //can be overwritten to identify routes with same types
  bool operator ==(Object other) {
    if (other is BolterRoute) {
      return runtimeType == other.runtimeType;
    }
    return false;
  }

  @override
  int get hashCode => runtimeType.hashCode;

  void complete() => _completer.complete(result);

  Future<R?> get whenComplete => _completer.future;
}

abstract class PersistedBolterRoute<R> extends BolterRoute<R> {}
